#ifndef __sockrpc_HXX
#include "sockrpc.hxx"
#endif

#ifndef __monitor_svc_HXX
#define __monitor_svc_HXX

#ifdef __GNUG__
#pragma interface
#endif

class YoodaMonitor : public SvcServer {
  public :
  YoodaMonitor(int family=AF_INET) : SvcServer("YoodaMonitor", family) {};
  YoodaMonitor(char* n, int f) : SvcServer(n,f) {}


  public :

  void listClients(  ListVal<InfoClient>& l_in, 
		    ListVal<InfoClient>& l_out) ;
  void killClient(int trid) ;
  void killServer() ;
  char* getname() ;

  public :

  class ReqRegister_listClients {
    public :
    int dummy ;
    ReqRegister_listClients(SvcServer* svc = SvcServer::_svcBase) {
      svc->reqRegister(YoodaMonitor::svc_listClients,0);
    } 
  } req_listClients ;
  static void svc_listClients(SvcSocket& __svc) {
    ListVal<InfoClient> l_in ;
    ListVal<InfoClient> l_out ;
    __svc >> l_in ;
    ( ((YoodaMonitor*)(&__svc))->listClients(l_in, l_out) );
    __svc << l_out << svcflush ;
  } ;

  class ReqRegister_killClient {
    public :
    int dummy ;
    ReqRegister_killClient(SvcServer* svc = SvcServer::_svcBase) {
      svc->reqRegister(YoodaMonitor::svc_killClient,1);
    } 
  } req_killClient ;
  static void svc_killClient(SvcSocket& __svc) {
    int trid ;
    __svc >> trid ;
    ( ((YoodaMonitor*)(&__svc))->killClient(trid) );
  } ;

  class ReqRegister_killServer {
    public :
    int dummy ;
    ReqRegister_killServer(SvcServer* svc = SvcServer::_svcBase) {
      svc->reqRegister(YoodaMonitor::svc_killServer,2);
    } 
  } req_killServer ;
  static void svc_killServer(SvcSocket& __svc) {
    ( ((YoodaMonitor*)(&__svc))->killServer() );
  } ;

  class ReqRegister_getname {
    public :
    int dummy ;
    ReqRegister_getname(SvcServer* svc = SvcServer::_svcBase) {
      svc->reqRegister(YoodaMonitor::svc_getname,3);
    } 
  } req_getname ;
  static void svc_getname(SvcSocket& __svc) {
    __svc << ( ((YoodaMonitor*)(&__svc))->getname() ) << svcflush ;
  } ;
} ;


#endif
