#include "ref_TstObjRoot.hxx"
#include "ref_TstObj.hxx"
#include "ref_MainObj.hxx"


const int DB_MAX_SERVER = 4 ;
const int DB_MAX_LARGE1 = 500 ;
const int DB_MAX_LARGE2 = 100000 ;
const int DB_ALARM_DELAY = 10000 ;
const int DB_VIRTUAL_RESULT = 1234 ;
extern const char* DB_NAME ;
extern Ref<MainObj> Main ;

class TstObjRoot : public ObjectX {
  public :

  virtual int test_virtual() {} ;


  public :
  static int yoo_ClId;
  static Ref<Cluster> yoo_Cluster;
  void* operator new(size_t s,void* addr)
  {
    return addr;
  }
  void* operator new(size_t s,Cluster* c=TstObjRoot::yoo_Cluster)
  {
    return ObjectX::operator new(s,c,TstObjRoot::yoo_ClId);
  }
  void* operator new(size_t s,ObjectX* o)
  {
    return ObjectX::operator new(s,o,TstObjRoot::yoo_ClId);
  }
  static void yoo_refresh(void* addr) 
  {
    YOO_LOAD_TIME = TRUE ;
    new(addr) TstObjRoot ;
    YOO_LOAD_TIME = FALSE ;
  }

  TstObjRoot() {}
} ;


class TstObj : public TstObjRoot {

  private :

  int        _offs ;
  int        _first ;
  StringX    _string ;
  int        _largeSize ;
  StringX    _large ;
  LocalListX<int> _list ;

  public :

  TstObj(int offs, int first) ;
  TstObj(const TstObj&) ;
  TstObj& operator=(const TstObj&) ;
  int modify(const Ref<TstObj>&) ;
  int verify(int offs) ;
  int test_virtual() ;


  public :
  static int yoo_ClId;
  static Ref<Cluster> yoo_Cluster;
  void* operator new(size_t s,void* addr)
  {
    return addr;
  }
  void* operator new(size_t s,Cluster* c=TstObj::yoo_Cluster)
  {
    return ObjectX::operator new(s,c,TstObj::yoo_ClId);
  }
  void* operator new(size_t s,ObjectX* o)
  {
    return ObjectX::operator new(s,o,TstObj::yoo_ClId);
  }
  static void yoo_refresh(void* addr) 
  {
    YOO_LOAD_TIME = TRUE ;
    new(addr) TstObj ;
    YOO_LOAD_TIME = FALSE ;
  }

  TstObj() {}
} ;
  
// workaround 'yoo_class' bug
typedef ListX<TstObj> TestList ; 

class MainObj : public ObjectX {
  public :
  
  int size ;
  LocalListX<TestList> list ;
  LocalListX<Cluster> clusters ;


  public :
  static int yoo_ClId;
  static Ref<Cluster> yoo_Cluster;
  void* operator new(size_t s,void* addr)
  {
    return addr;
  }
  void* operator new(size_t s,Cluster* c=MainObj::yoo_Cluster)
  {
    return ObjectX::operator new(s,c,MainObj::yoo_ClId);
  }
  void* operator new(size_t s,ObjectX* o)
  {
    return ObjectX::operator new(s,o,MainObj::yoo_ClId);
  }
  static void yoo_refresh(void* addr) 
  {
    YOO_LOAD_TIME = TRUE ;
    new(addr) MainObj ;
    YOO_LOAD_TIME = FALSE ;
  }

  MainObj() {}
} ;


