#ifdef __GNUG__
#pragma implementation "listx_tmpl.hxx"
#pragma implementation "smartp_tmpl.hxx"
#pragma implementation "c++_const.hxx"
#pragma implementation "dictionary_tmpl.hxx"
#pragma implementation "dbvue_clnt.hxx"
#pragma implementation "callbackclient_clnt.hxx"
#pragma implementation "callbackserver_clnt.hxx"
#pragma implementation "iter_tmpl.hxx"
#endif

#include "yoo_root.hxx"
#include "dictionary.hxx"
#define __YOODA_MAIN

#include "listln.hxx"
#include "dict.hxx"
#include "oo7s3.hxx"

template class Iterator<ADM_SchFile> ;
template class Iterator<ObjectX> ;
template class Iterator<ADM_Clu> ;
template class Iterator<ADM_Vol> ;
template class Iterator<ADM_Class> ;
template class Iterator<ADM_NameObj> ;
template class Iterator<ADM_Server> ;

template class LocalListX<ADM_SchFile> ;
template class LocalListX<ObjectX> ;
template class LocalListX<ADM_Clu> ;
template class LocalListX<ADM_Vol> ;
template class LocalListX<ADM_Class> ;
template class LocalListX<ADM_NameObj> ;
template class LocalListX<ADM_Server> ;

template class ListX<ADM_SchFile> ;
template class ListX<ObjectX> ;
template class ListX<ADM_Clu> ;
template class ListX<ADM_Vol> ;
template class ListX<ADM_Class> ;
template class ListX<ADM_NameObj> ;
template class ListX<ADM_Server> ;

Ref<ADM_Admin> YoodaDictionary ;

extern void (*YOO_TabRefresh[]) (void *) ;
void yoo_refreshInit() {
  //0 reserved for non C++ objects
  YOO_TabRefresh[3] = ListNode::yoo_refresh ;
  YOO_TabRefresh[4] = ListLeaf::yoo_refresh ;
  YOO_TabRefresh[5] = DictNode::yoo_refresh ;
  YOO_TabRefresh[6] = DictLeaf::yoo_refresh ;

  YoodaDictionary.setOid(OID(YOO_ADMIN_VOL, YOO_FIRST_USED_PAGE, 3)) ;
  YOO_DEF_CLU = YoodaDictionary->defClu->clu ; 



  ADM_Class* cl ;
  Assembly::yoo_ClId = 12 ;
  cl = YoodaDictionary->dictClass.getFirst("Assembly");
  if (cl == NULL) { 
    cerr << "Assembly" << " : unknown class" << endl;
  }
  Assembly::yoo_Cluster=cl->myClu->clu;
  YOO_TabRefresh[12] = Assembly::yoo_refresh ;

  AtomicPart::yoo_ClId = 7 ;
  cl = YoodaDictionary->dictClass.getFirst("AtomicPart");
  if (cl == NULL) { 
    cerr << "AtomicPart" << " : unknown class" << endl;
  }
  AtomicPart::yoo_Cluster=cl->myClu->clu;
  YOO_TabRefresh[7] = AtomicPart::yoo_refresh ;

  BaseAssembly::yoo_ClId = 14 ;
  cl = YoodaDictionary->dictClass.getFirst("BaseAssembly");
  if (cl == NULL) { 
    cerr << "BaseAssembly" << " : unknown class" << endl;
  }
  BaseAssembly::yoo_Cluster=cl->myClu->clu;
  YOO_TabRefresh[14] = BaseAssembly::yoo_refresh ;

  ComplexAssembly::yoo_ClId = 13 ;
  cl = YoodaDictionary->dictClass.getFirst("ComplexAssembly");
  if (cl == NULL) { 
    cerr << "ComplexAssembly" << " : unknown class" << endl;
  }
  ComplexAssembly::yoo_Cluster=cl->myClu->clu;
  YOO_TabRefresh[13] = ComplexAssembly::yoo_refresh ;

  CompositePart::yoo_ClId = 9 ;
  cl = YoodaDictionary->dictClass.getFirst("CompositePart");
  if (cl == NULL) { 
    cerr << "CompositePart" << " : unknown class" << endl;
  }
  CompositePart::yoo_Cluster=cl->myClu->clu;
  YOO_TabRefresh[9] = CompositePart::yoo_refresh ;

  Connection::yoo_ClId = 8 ;
  cl = YoodaDictionary->dictClass.getFirst("Connection");
  if (cl == NULL) { 
    cerr << "Connection" << " : unknown class" << endl;
  }
  Connection::yoo_Cluster=cl->myClu->clu;
  YOO_TabRefresh[8] = Connection::yoo_refresh ;

  Document::yoo_ClId = 10 ;
  cl = YoodaDictionary->dictClass.getFirst("Document");
  if (cl == NULL) { 
    cerr << "Document" << " : unknown class" << endl;
  }
  Document::yoo_Cluster=cl->myClu->clu;
  YOO_TabRefresh[10] = Document::yoo_refresh ;

  DummyObj::yoo_ClId = 16 ;
  cl = YoodaDictionary->dictClass.getFirst("DummyObj");
  if (cl == NULL) { 
    cerr << "DummyObj" << " : unknown class" << endl;
  }
  DummyObj::yoo_Cluster=cl->myClu->clu;
  YOO_TabRefresh[16] = DummyObj::yoo_refresh ;

  Manual::yoo_ClId = 11 ;
  cl = YoodaDictionary->dictClass.getFirst("Manual");
  if (cl == NULL) { 
    cerr << "Manual" << " : unknown class" << endl;
  }
  Manual::yoo_Cluster=cl->myClu->clu;
  YOO_TabRefresh[11] = Manual::yoo_refresh ;

  Module::yoo_ClId = 15 ;
  cl = YoodaDictionary->dictClass.getFirst("Module");
  if (cl == NULL) { 
    cerr << "Module" << " : unknown class" << endl;
  }
  Module::yoo_Cluster=cl->myClu->clu;
  YOO_TabRefresh[15] = Module::yoo_refresh ;

}

Ref<Cluster> Assembly::yoo_Cluster ;
int Assembly::yoo_ClId ;
template class Ref<Assembly> ;
template class ListX<Assembly> ;
template class Iterator<Assembly> ;
Ref<Cluster> AtomicPart::yoo_Cluster ;
int AtomicPart::yoo_ClId ;
template class Ref<AtomicPart> ;
template class ListX<AtomicPart> ;
template class Iterator<AtomicPart> ;
Ref<Cluster> BaseAssembly::yoo_Cluster ;
int BaseAssembly::yoo_ClId ;
template class Ref<BaseAssembly> ;
template class ListX<BaseAssembly> ;
template class Iterator<BaseAssembly> ;
Ref<Cluster> ComplexAssembly::yoo_Cluster ;
int ComplexAssembly::yoo_ClId ;
template class Ref<ComplexAssembly> ;
template class ListX<ComplexAssembly> ;
template class Iterator<ComplexAssembly> ;
Ref<Cluster> CompositePart::yoo_Cluster ;
int CompositePart::yoo_ClId ;
template class Ref<CompositePart> ;
template class ListX<CompositePart> ;
template class Iterator<CompositePart> ;
Ref<Cluster> Connection::yoo_Cluster ;
int Connection::yoo_ClId ;
template class Ref<Connection> ;
template class ListX<Connection> ;
template class Iterator<Connection> ;
Ref<Cluster> Document::yoo_Cluster ;
int Document::yoo_ClId ;
template class Ref<Document> ;
template class ListX<Document> ;
template class Iterator<Document> ;
Ref<Cluster> DummyObj::yoo_Cluster ;
int DummyObj::yoo_ClId ;
template class Ref<DummyObj> ;
template class ListX<DummyObj> ;
template class Iterator<DummyObj> ;
Ref<Cluster> Manual::yoo_Cluster ;
int Manual::yoo_ClId ;
template class Ref<Manual> ;
template class ListX<Manual> ;
template class Iterator<Manual> ;
Ref<Cluster> Module::yoo_Cluster ;
int Module::yoo_ClId ;
template class Ref<Module> ;
template class ListX<Module> ;
template class Iterator<Module> ;
void (*YOO_TabRefresh[17]) (void*) ;
int YOO_LastClassId = 16;
