#ifndef oo_type_HXX
#define oo_type_HXX

#ifndef oobd_HXX
#include "oobd.hxx"
#endif


#define NUM_TYPE 2048

class BD_Type {
  public :

  SharedSet<BD_Objet> objets ;

  int typeIdent ;

  static SharedSetIterator<BD_Objet>* iter[NUM_TYPE] ;

  static void reset() {
    for (int i = 0; i < NUM_TYPE; i++) {
      if (iter[i] != NULL) {
        delete iter[i] ;
        iter[i] = NULL ;
      }
    }
  }

  BD_Type(int typ) : typeIdent(typ) {}

  // Renvoie le nombre d'objets dans le type
  int nombreObjets() { return objets.count() ; }  

  // Renvoie l'objet precedent ou suivant en partant de l'objet passe
  // en parametre. Le debut de parcours peut etre positionne en tete ou en fin
  BD_Objet* parcourirType(BD_CodeParc, BD_Objet* courant = NULL) ;

  // Renvoie l'objet de rang n dans le type
  BD_Objet* lireObjet(int rang) ;
} ;


#endif
