#ifndef __sockrpc_HXX
#include "sockrpc.hxx"
#endif

#ifndef __class_svc_HXX
#define __class_svc_HXX

/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */



class MonObjServ : public SvcServer {
  public :
  MonObjServ(int family=AF_INET) : SvcServer("MonObjServ", family) {};
  MonObjServ(char* n, int f) : SvcServer(n,f) {}


/*  dfgdfgfgdf */
  public :
	
  int publish(char*& serv, char*& filtre, int& port, int& nbinst/* ghghf*/) ; 
  char* subscript(char*& serv, /* fghghf */char*& filtre,  int& port) ;
  void bench( OID& oid,  Page& /*fghgfh*/page) ;

  public :

  class ReqRegister_publish {
    public :
    int dummy ;
    ReqRegister_publish(SvcServer* svc = SvcServer::_svcBase) {
      svc->reqRegister(MonObjServ::svc_publish,0);
    } 
  } req_publish ;
  static void svc_publish(SvcSocket& __svc) {
    char* serv ;
    char* filtre ;
    int port ;
    int nbinst ;
    __svc >> serv >> filtre >> port >> nbinst ;
    __svc << ( ((MonObjServ*)(&__svc))->publish(serv, filtre, port, nbinst) ) << svcflush ;
    delete serv ;
    delete filtre ;
  } ;

  class ReqRegister_subscript {
    public :
    int dummy ;
    ReqRegister_subscript(SvcServer* svc = SvcServer::_svcBase) {
      svc->reqRegister(MonObjServ::svc_subscript,1);
    } 
  } req_subscript ;
  static void svc_subscript(SvcSocket& __svc) {
    char* serv ;
    char* filtre ;
    int port ;
    __svc >> serv >> filtre ;
    __svc << ( ((MonObjServ*)(&__svc))->subscript(serv, filtre, port) ) << port << svcflush ;
    delete serv ;
    delete filtre ;
  } ;

  class ReqRegister_bench {
    public :
    int dummy ;
    ReqRegister_bench(SvcServer* svc = SvcServer::_svcBase) {
      svc->reqRegister(MonObjServ::svc_bench,2);
    } 
  } req_bench ;
  static void svc_bench(SvcSocket& __svc) {
    OID oid ;
    Page page ;
    __svc >> oid ;
    ( ((MonObjServ*)(&__svc))->bench(oid, page) );
    __svc << page << svcflush ;
  } ;
} ;



#endif
